#include <mpi.h>;

int main(int argc, char** argv) {
  MPI_Comm parent;
  MPI_Status status;
  int size;
  int value = -1;
  void* buf= &value;

  printf("Hi argc %d\n",argc);
  if (argc > 1)
  {
    printf("argv1 %s", argv[1]);
  }

  if (MPI_Init(&argc,&argv)!=MPI_SUCCESS)
  {
    printf("MPI_Init failed");
  }

  MPI_Comm_get_parent(&parent);
  if (parent == MPI_COMM_NULL) printf("No parent!");

  MPI_Comm_remote_size(parent, &size);
  printf("Hi size %d\n",size);

  int world_rank;
  MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
  printf("Hi rank %d\n",world_rank);

  printf("before recv %d\n",value);
  MPI_Recv(buf, 1, MPI_INTEGER, 0, MPI_ANY_TAG, parent, &status);
  printf("after recv %d\n",value);

  MPI_Finalize();
  return 0;
}
